/*
 * Copyright (c) 2007-2011 by The Broad Institute of MIT and Harvard.  All Rights Reserved.
 *
 * This software is licensed under the terms of the GNU Lesser General Public License (LGPL),
 * Version 2.1 which is available at http://www.opensource.org/licenses/lgpl-2.1.php.
 *
 * THE SOFTWARE IS PROVIDED "AS IS." THE BROAD AND MIT MAKE NO REPRESENTATIONS OR
 * WARRANTES OF ANY KIND CONCERNING THE SOFTWARE, EXPRESS OR IMPLIED, INCLUDING,
 * WITHOUT LIMITATION, WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, NONINFRINGEMENT, OR THE ABSENCE OF LATENT OR OTHER DEFECTS, WHETHER
 * OR NOT DISCOVERABLE.  IN NO EVENT SHALL THE BROAD OR MIT, OR THEIR RESPECTIVE
 * TRUSTEES, DIRECTORS, OFFICERS, EMPLOYEES, AND AFFILIATES BE LIABLE FOR ANY DAMAGES
 * OF ANY KIND, INCLUDING, WITHOUT LIMITATION, INCIDENTAL OR CONSEQUENTIAL DAMAGES,
 * ECONOMIC DAMAGES OR INJURY TO PROPERTY AND LOST PROFITS, REGARDLESS OF WHETHER
 * THE BROAD OR MIT SHALL BE ADVISED, SHALL HAVE OTHER REASON TO KNOW, OR IN FACT
 * SHALL KNOW OF THE POSSIBILITY OF THE FOREGOING.
 */

package edu.mit.broad.prodinfo.multiplealignment;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;

import edu.mit.broad.prodinfo.genomicplot.ParseException;

public interface MultipleAlignmentIO {
	MultipleAlignment load(String fileName) throws IOException, ParseException;
	MultipleAlignment load(InputStream in) throws IOException, ParseException;
	MultipleAlignment load(String fileName, List<String> sequencesToLoad) throws IOException, ParseException;
	MultipleAlignment load(InputStream in, List<String> sequencesToLoad) throws IOException, ParseException;
	void write(BufferedWriter bw, MultipleAlignment ma) throws IOException;
	void write(BufferedWriter bw, MultipleAlignment ma, List<String> orderOfSequences) throws IOException ;
	String getPreferredFileExtension();
}
