/*
 * Copyright (c) 2007-2011 by The Broad Institute of MIT and Harvard.  All Rights Reserved.
 *
 * This software is licensed under the terms of the GNU Lesser General Public License (LGPL),
 * Version 2.1 which is available at http://www.opensource.org/licenses/lgpl-2.1.php.
 *
 * THE SOFTWARE IS PROVIDED "AS IS." THE BROAD AND MIT MAKE NO REPRESENTATIONS OR
 * WARRANTES OF ANY KIND CONCERNING THE SOFTWARE, EXPRESS OR IMPLIED, INCLUDING,
 * WITHOUT LIMITATION, WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, NONINFRINGEMENT, OR THE ABSENCE OF LATENT OR OTHER DEFECTS, WHETHER
 * OR NOT DISCOVERABLE.  IN NO EVENT SHALL THE BROAD OR MIT, OR THEIR RESPECTIVE
 * TRUSTEES, DIRECTORS, OFFICERS, EMPLOYEES, AND AFFILIATES BE LIABLE FOR ANY DAMAGES
 * OF ANY KIND, INCLUDING, WITHOUT LIMITATION, INCIDENTAL OR CONSEQUENTIAL DAMAGES,
 * ECONOMIC DAMAGES OR INJURY TO PROPERTY AND LOST PROFITS, REGARDLESS OF WHETHER
 * THE BROAD OR MIT SHALL BE ADVISED, SHALL HAVE OTHER REASON TO KNOW, OR IN FACT
 * SHALL KNOW OF THE POSSIBILITY OF THE FOREGOING.
 */

package org.broad.igv.vcf;

import java.io.*;

/**
 * @author jrobinso
 * @date Apr 25, 2011
 */
public class AutismUtils {


    public static void main(String[] args) throws IOException {
        createSampleMap();
    }

    private static void createLoadXML() throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader("/Users/jrobinso/IGV/autism/bam_locations.txt"));

        PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter("/Users/jrobinso/IGV/autism/bam.xml")));

        String nextLine;
        while ((nextLine = reader.readLine()) != null) {

            String bamPath = nextLine.trim();
            String url = bamPath.replace("/seq", "http://iwww.broadinstitute.org/igvdata");
            String name = (new File(bamPath)).getName().replace(".bam", "");

            writer.println("   <Resource name=\"" + name + "\"");
            writer.println("             path=\"" + url + "\"/>");

        }

        reader.close();
        writer.close();
    }

    private static void createSampleMap() throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader("/Users/jrobinso/IGV/autism/bam_locations.txt"));

        PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter("/Users/jrobinso/IGV/autism/samplemap.txt")));

        String nextLine;
        while ((nextLine = reader.readLine()) != null) {

            String bamPath = nextLine.trim();
            String url = bamPath.replace("/seq", "http://iwww.broadinstitute.org/igvdata");
            String name = (new File(bamPath)).getName().replace(".bam", "");

            writer.println(name + "\t" + url);

        }

        reader.close();
        writer.close();
    }
}
